#include  <math.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

#define   N    1000
#define   T    2000
#define   P    1
#define   AG   10

int      node[N][N];
int      state[N];
int      temp[N];
double   inf[T];
double   avedeg[T];
int      deg[N];
int      inftimes[N];

//FILE  *fp1=fopen("edge_la4900.txt","r");
FILE  *fp1=fopen("edge_ba,z=16,10000.txt","r");
FILE  *fp2=fopen("infect.txt","w");
FILE  *fp3=fopen("speed.txt","w");
FILE  *fp4=fopen("domain.txt","w");
FILE  *fp5=fopen("infect_degree_ave.txt","w");
FILE  *fp6=fopen("infect_deg-dis.txt","w");
FILE  *fp7=fopen("inf_times.txt","w");

void input(void)
{
	int a,b;
	int i,j;
	for(i=0;i<N;i++)
	{
		for(j=0;j<N;j++)
		{
			node[i][j]=0;
		}
	}
	while((fscanf(fp1,"%d %d ",&a,&b))==2)
	{
		node[a][b]=node[b][a]=1;
	}
	int m;
	for(i=0;i<N;i++)
	{
		m=0;
		for(j=0;j<N;j++)
		{
			if(node[i][j]==1)
			{
				m++;
			}
		}
		deg[i]=m;
	}
}


void initial(void)
{
	int i;
	for(i=0;i<T;i++)
	{
		inf[i]=0;
		avedeg[i]=0;
	}
	for(i=0;i<N;i++)
	{
		state[i]=temp[i]=0;
	}
}

void infection(int t)
{
	int i,j;
	int ti=0;
	double frand;
	for(i=0;i<N;i++)
	{
		state[i]=temp[i];
	}
	for(i=0;i<N;i++)
	{
		temp[i]=0;
	}
	for(i=0;i<N;i++)
	{
		if(state[i]==1)
		{
			for(j=0;j<N;j++)
			{
				if(node[i][j]==1)
				{
    				frand=(double)rand()/RAND_MAX;
    				if(frand<P)
					{
						temp[j]=1;
						inftimes[j]++;
						ti++;
						avedeg[t]+=deg[j];
					}
				}
			}
		}
	}
	avedeg[t]/=ti;
	for(i=0;i<N;i++)
	{
		state[i]=0;
	}
}

void  tongji(int t)
{
	int i;
	for(i=0;i<N;i++)
	{
		if(temp[i]==1)
		{
			inf[t]++;
		}
	}
	inf[t]/=N;
}

void  output(void)
{
	int i;
	for(i=1;i<T;i++)
	{
		fprintf(fp2,"%lf\n",inf[i]);
		fprintf(fp3,"%lf\n",inf[i]-inf[i-1]);
		fprintf(fp5,"%lf\n",avedeg[i]);
	}
	fprintf(fp4,"%lf\n",inf[T-1]);
	for(i=0;i<N;i++)
	{
		if(temp[i]==1)
			fprintf(fp6,"%d\n",deg[i]);
		fprintf(fp7,"%d %d\n",deg[i],inftimes[i]);
	}
}

int main(void)
{
	int i,j;
	srand((unsigned)time(NULL));
    input();
//	temp[2000]=1;
	for(i=0;i<N;i++)
	{
		inftimes[i]=0;
	}
	for(j=0;j<AG;j++)
	{
		printf("%d\n",j);
	initial();
	temp[1000]=1;
	for(i=0;i<T;i++)
	{
//		if(i%100==0)
//			printf("%d\n",i);
		infection(i);
		tongji(i);
	}

	for(i=0;i<T;i++)
	  printf("%d \n",inf[i]);
    
  //  if(inf[T-1]>0)
//	{
		output();
//		break;
//	}

	}
return 0;
}
