//Draw algorithum
function mark_sis(t,g)
for i=1:length(t)
 g('node_color')(1,t(i))=0;
 show_nodes(t(i),'sup');
 if t(i)==t(i+1)
   break;
 end
end
endfunction

function draw_com(a,b,i)
[x,y,q,num]=scidecom(a,b);
x=1:length(num);
bar(x,num);
xtitle( 'Community Distribution', 'C(i)', 'P(i)') ;
endfunction

function plot_inf(t,inf)
 i=[2:t];
 plot(i,inf(i));
 xtitle( 'Epidemic process', 'T', 'Inf(t)') ;
endfunction



function draw_graph(g,scale)
mdegree=nodes_degrees(g);
maxdegree=max(nodes_degrees(g));
k0=[];
k1=[];
k2=[];
k3=[];
k4=[];
k5=[];
x=[];
y=[];
gcolor=[];
gdiam=[];
gedge=[];
i0=1;
i1=1
i2=1
i3=1;
i4=1;
i5=1;
winId=waitbar('calculating the model...');
for i=1:g('node_number')
waitbar(round(i/g('node_number')*100)/100,winId);
   if mdegree(i)<=maxdegree & mdegree(i)>maxdegree/2
      k0(i0)=i;
      i0=i0+1;
      continue;
   end 
   if mdegree(i)<=maxdegree/2 & mdegree(i)>maxdegree/4
      k1(i1)=i;
      i1=i1+1;
      continue;
   end
   if mdegree(i)<=maxdegree/4 & mdegree(i)>maxdegree/8
      k2(i2)=i;
      i2=i2+1;
      continue;
   end
   if mdegree(i)<=maxdegree/8 & mdegree(i)>maxdegree/16
      k3(i3)=i;
      i3=i3+1;
      continue;
   end
   if mdegree(i)<=maxdegree/16 & mdegree(i)>maxdegree/32
      k4(i4)=i;
      i4=i4+1;
      continue;
   end
   if mdegree(i)<=maxdegree/32 & mdegree(i)>=0
      k5(i5)=i;
      i5=i5+1;
      continue;
   end
end

if i0<>1
eg=2*%pi/(i0-1);
for i=1:i0-1
x(k0(i))=800+100*sin(i*eg);
y(k0(i))=800-100*cos(i*eg);
gcolor(k0(i))=6;
gdiam(k0(i))=round(20/sqrt(i0))+1;
gedge(k0(i))=gdiam(k0(i))+2;
end
end

if i1<>1
eg=2*%pi/(i1-1);
for i=1:i1-1
x(k1(i))=800+200*sin(i*eg);
y(k1(i))=800-200*cos(i*eg);
gcolor(k1(i))=2;
gdiam(k1(i))=round(15/sqrt(i1))+1;
gedge(k1(i))=gdiam(k1(i))+3;
end
end

if i2<>1
eg=2*%pi/(i2-1);
for i=1:i2-1
x(k2(i))=800+300*sin(i*eg);
y(k2(i))=800-300*cos(i*eg);
gcolor(k2(i))=3;
gdiam(k2(i))=round(10/sqrt(i2))+1;
gedge(k2(i))=gdiam(k2(i))+3;
end
end

if i3<>1
eg=2*%pi/(i3-1);
for i=1:i3-1
x(k3(i))=800+400*sin(i*eg);
y(k3(i))=800-400*cos(i*eg);
gcolor(k3(i))=4;
gdiam(k3(i))=round(9/sqrt(i3))+3;
gedge(k3(i))=gdiam(k3(i));
end
end

if i4<>1
eg=2*%pi/(i4-1);
for i=1:i4-1
x(k4(i))=800+500*sin(i*eg);
y(k4(i))=800-500*cos(i*eg);
gcolor(k4(i))=5;
gdiam(k4(i))=5;
gedge(k4(i))=gdiam(k4(i));
end
end

if i5<>1
eg=2*%pi/(i5-1);
for i=1:i5-1
x(k5(i))=800+600*sin(i*eg);
y(k5(i))=800-600*cos(i*eg);
gcolor(k5(i))=6;
gdiam(k5(i))=3;
gedge(k5(i))=gdiam(k5(i));
end
end

for i=1:g('node_number')
  g('node_y')(1,i)=y(i); 
  g('node_x')(1,i)=x(i);
  g('node_color')(1,i)=gcolor(i);
  g('node_diam')(1,i)=gdiam(i);
  g('node_border')(1,i)=gedge(i);
end
winclose(winId);
show_graph(g,scale);


endfunction


function draw_degree(g,flag)
x=1:max(nodes_degrees(g));
//xset("mark size",1);
if flag==0
plot2d(x,degree_stat(g),logflag='nn',style=-4);
end
if flag==2
plot2d(x,degree_stat(g),logflag='ll',style=-4);
end
if flag==1
plot2d(x,degree_stat(g),logflag='nl',style=-4);
end

xtitle( 'Degree Distribution', 'K', 'P(K)') ;
//xgrid();
endfunction

function draw_betweenness(t,bt,flag)
l=length(bt);
i=[1:l];
if flag==0
plot2d(t(i,1),bt(i),logflag='nn',style=-4);
end
if flag==1
plot2d(t(i,1),bt(i),logflag='nl',style=-4);
end
if flag==2
plot2d(t(i,1),bt(i),logflag='ll',style=-4);
end

xtitle( 'betweenness Distribution', 'K', 'BC(K)') ;
endfunction





