//Strategy functions
//By WuBo
//Revise by 06.8.23

//Attack Function
function node=max_degree(g)
k_max=0;
mdegree=nodes_degrees(g);
  for i=1:g.node_number
    if k_max<=mdegree(i)
         k_max=mdegree(i);
         node=i;
    end
  end
endfunction

////////////////////////////////////////////////////
//The attack function
//g:the name of the graph
//t:the attack time step
//flag: 0-choose the node randomly
//      1-choose the link randomly    
//      2-choose the vertex with the maximum degree
////////////////////////////////////////////////////
function g1=attack(g,t,flag)

if flag==0      
  for tt=1:t
    att_node=int(rand()*g.node_number)+1;
    g=delete_nodes(att_node,g);
    tt=tt+1;
  end
end


if flag==1     
tt=1;
  while tt<=t
    head=int(rand()*g.node_number)+1;
    zz=neighbors(head,g);
    if zz>0   //prevent choosing the node with degree=0
    z=int(rand()*length(zz))+1;
    tail=zz(z);
    g=delete_arcs([head tail],g);
    tt=tt+1;
    end 
  end
end

if flag==2      
   for tt=1:t
   att_node=max_degree(g);
   g=delete_nodes(att_node,g);
   tt=tt+1;
  end
end
g1=g;
endfunction

///////////////////////////////////////////////////////
//Calculate the traffic efficiency                   //  
///////////////////////////////////////////////////////
function eff=efficiency(g)
    eff=0;
    winId=waitbar('Calculate the efficiency...');
    for i=1:g.node_number-1
     waitbar(round(i/g.node_number*100)/100,winId);
        for j=i+1:g.node_number
  //            if j<>i
                 [a b]=shortest_path(i,j,g);
                    if b<>-1 & b<>0
                       eff=eff+1/b;
 //                   end  
              end
        end
    end
    winclose(winId);
    eff=eff*2/g.node_number/(g.node_number-1);
endfunction    


//Random Walk model (Random Diffusion(RD) )
//Here, given the complicated case of directed graph
//we choose the undirected graph.
function path=randwalk(g,i,j)
  start=i;
  t=0;
  path=0;
  while t<%inf
  zz=neighbors(start,g);
      if zz>0
      z=int(rand()*length(zz))+1;
      path=path+1;
        if zz(z)==j
        return path;
        else start=zz(z);
        end
  end
  t=t+1;
  end
endfunction 









